#include <cstdio>
#include <ctime>
#include <cassert>
#include <cstdlib>
#include <cstring>
#include <cmath>
#include <set>
#include <map>
#include <vector>
#include <algorithm>
#include <string>
#include <iostream>
using namespace std;

#define pb push_back
#define mp make_pair
#define fs first
#define sc second

const int MaxM=8;
const int MaxN=100;
const int MaxProfiles=3000;
const int MaxComponents=(MaxM+1)/2;
const int Base=MaxComponents+1;

int ans[MaxN+1][MaxProfiles];
int m, km;
vector<int> trans[MaxProfiles], profiles;
bool reach[MaxProfiles];

int power(int a, int b)
{
	if(b==0) return 1; else return power(a, b-1)*a;
}
void build_profiles()
{
	int profile[MaxM+1], cnt[MaxComponents+1];
	profiles.clear();
	int theory_max_profiles=power((MaxComponents+1), m+1);
	for(int k=0; k<theory_max_profiles; ++k)
	{
		int cur=k;
		for(int j=0; j<=m; ++j)
			profile[j]=cur%Base, cur/=Base;
		bool ok=true;
		int last=0;
		for(int j=0; j<=m; ++j)
			if(profile[j]>0)
			{
				if(profile[j]>last+1)
					ok=false;
				if(profile[j]>last)
					last=profile[j];
			}
		for(int j=0; j<=MaxComponents; ++j)
			cnt[j]=0;
		for(int j=0; j<=m; ++j)
			cnt[profile[j]]++;
		int mx=0;
		for(int j=0; j<=MaxComponents; ++j)
			if(cnt[j]>0)
				mx=j;
		for(int j=1; j<=mx; ++j)
			if(cnt[j]!=2) ok=false;
		if(ok)
			profiles.pb(k);
	}
}
int profile[MaxM+1], nprofile[MaxM+1], p[MaxM+1], deg[MaxM+1], real[MaxM+1];
bool unfinished[MaxM+1];
int find(int x)
{
	if(x!=p[x]) p[x]=find(p[x]);
	return p[x];
}
void Union(int u, int v)
{
	u=find(u); v=find(v);
	p[v]=u;
}
bool build_profile(int current, int mask, int& result)
{
	int ocurrent=current;
	for(int i=0; i<=m; ++i)
	{
		profile[i]=current%Base, current/=Base;
		deg[i]=(profile[i]!=0);
	}
	for(int i=0; i<=m; ++i)
		p[i]=i;
	for(int i=0; i<=m; ++i)
		for(int j=i+1; j<=m; ++j)
			if((profile[i]==profile[j])&&(profile[j]!=0))
				Union(p[i], p[j]);
	for(int i=0; i<m; ++i)
		if(mask&(1<<i))
		{
			deg[i]++, deg[i+1]++;
			Union(p[i], p[i+1]);
		}
	for(int i=0; i<=m; ++i)
		if(deg[i]>2) return false;
	for(int i=0; i<=m; ++i)
	{
		p[i]=find(p[i]);
		real[i]=0;
		unfinished[i]=false;
	}
	for(int i=0; i<=m; ++i)
		if(deg[i]==1)
			unfinished[p[i]]=true;
	int last=-1;
	for(int i=0; i<=m; ++i)
		if((profile[i]!=0)&&(!unfinished[p[i]]))
			if(last==-1)
				last=p[i];
			else
				if(last!=p[i])
					return false;
	int ncomp=0;
	for(int i=0; i<=m; ++i)
		if(deg[i]==1)
		{
			if(real[p[i]]==0)
			{
				ncomp++;
				real[p[i]]=ncomp;
			}
			nprofile[i]=real[p[i]];
		}
		else
			nprofile[i]=0;
	result=0;
	for(int i=m; i>=0; --i)
		result=result*Base+nprofile[i];
	if((last!=-1)&&(result!=0)) return false;
	return true;
}
void build_transformations()
{
	int ncur, all_trans=0;
	for(int i=0; i<profiles.size(); ++i)
	{
		trans[i].clear();
		for(int j=0; j<(1<<m); ++j)
			if(build_profile(profiles[i], j, ncur))
				if(ncur!=0)
				{
					int ind=lower_bound(profiles.begin(), profiles.end(), ncur)-profiles.begin();
					trans[i].pb(ind);
					all_trans++;
				}
				else
					reach[i]=true;
	}
	//fprintf(stderr, "Profiles: %d\nTransformations: %d\n", profiles.size(), all_trans);
	reach[0]=false;
}
int n;
int calc_answer()
{
	int sum=0;
	for(int j=0; j<trans[0].size(); ++j)
		ans[0][trans[0][j]]++;
	for(int i=0; i<n; ++i)
	{
		ans[i][0]=1;
		for(int j=0; j<profiles.size(); ++j)
			if(ans[i][j]>0)
			{
				if(reach[j])
					sum=(sum+ans[i][j])%km;
				for(int k=0; k<trans[j].size(); ++k)
					ans[i+1][trans[j][k]]=(ans[i+1][trans[j][k]]+ans[i][j])%km;
			}
	}
	if(sum%km==0)
		return km;
	else
		return sum%km;
}
int main()
{
	scanf("%d%d%d", &n, &m, &km);
	build_profiles();
	build_transformations();
	printf("%d\n", calc_answer());
	return 0;
}
